
#include <event.h>

#include "dvbrc.h" /* Needed for type definitions. unclean. */

#define DEBUG

#define MAX_MCAST_PAYLOAD	(1500-40)
#define TS_PACKET_SIZE		188

#define MAXSENDOVERFLOWS	500	/* After this many overflows the connection gets dropped */

enum {
	PID_NONE = 0,
	PID_PMT,
	PID_VIDEO,
	PID_AUDIO,
	PID_OTHER,
	PID_SPECIALPID
};

struct unicast_client {
	struct unicast_client *	next;
	int			sockfd;
	struct event		ev;
	unsigned long		sendoverflows;
	char			hadrequest;
};

struct stream {
	struct stream *		next;
	struct channel *	channel;
	struct unicast_client *	ucclients;
	int			nuccs; /* Number of UniCast Clients; -1 = multicast */
	struct event		ev; /* Only needed for unicast */
	int			cid;
	int			sockfd;
	int			pbufvalid;
	unsigned char 		pbuf[MAX_MCAST_PAYLOAD];
	char			ipaddr[128];
	int			port;
	int			ttl;
	unsigned int		apid, vpid, opid;
	char			pid0cc;
};

struct pidentry {
	unsigned char		type,
				cc;
	time_t			lastvalid;
	struct stream *		s;
};

extern struct stream *		streams;
extern unsigned int		maxuccs; /* Maximum number of unicast clients */

/* Some functions */
void drop_tcp_connection(struct stream * s, int fd);
void setfdnonblocking(int fd);
