#!/bin/bash

# Channel     VID   AID                                 PID   TID
# Sat.1       385   386(deu),392(ac3),            391   16408 13057 Tde-Nuernberg     626000      2/3   -     16    -     8     8     1/4
# ProSieben   305   306(deu),312(ac3),            311   16403 13057 Tde-Nuernberg     626000      2/3   -     16    -     8     8     1/4
# kabel eins  161   162(deu),                     167   16394 13057 Tde-Nuernberg     626000      2/3   -     16    -     8     8     1/4
# N24         225   226(deu),                     231   16398 13057 Tde-Nuernberg     626000      2/3   -     16    -     8     8     1/4

maxcon="5"
myip="192.168.0.1"
if [ -z "$1" ]
then
	selcrd="0"
else
	selcrd="$1"
fi
let "epgport = selcrd + 4000"
let "timport = epgport + 100"
echo "Trying to run unicast stream from ${selcrd} with maxcon=${maxcon} - EPG on port ${epgport}"
./getstream -a ${selcrd} \
	-f dvbrc-dvb-t-nuernberg \
	-l ${maxcon} \
	-d 1 \
	-p -18:${myip}:${epgport} \
	-p -20:${myip}:${timport} \
	-p 16394:${myip}:2001 \
	-p 16398:${myip}:2002 \
	-p 16403:${myip}:2003 \
	-p 16408:${myip}:2004
