#!/usr/bin/perl
use strict;

my $chan_file = "dvbrc-dvb-s-astra";
my $ip = "192.168.0.1";
my $playlistinfo = '/home/tvstream/.plst-%s-adapter%d.part';
# Set to '' if you don't need to copy the playlist elsewhere, that will skip
# calling scp.
my $plstarget = '';
#my $plstarget = 'tvstream@127.0.0.1:';

my ($frequency, $adapter, $transponder, $multicast);
while ($_ = shift) {
	if ($_ > 10000) {
		$frequency = $_;
	} elsif ($_ > 3) {
		$transponder = $_;
	} elsif (/^\d*$/) {
		$adapter = $_;
	} else {
		$multicast = 1 if (/^-*m$/)
	}
}
$adapter     = 0 unless ($adapter);
$transponder = $adapter unless ($transponder);

unless ($frequency) {
	print "usage: stream-transponder [-m] <frequency> [<adapter>] [<transponder>]\n";
	exit;
}

my $command = "./getstream -a $adapter -f $chan_file -l 25 -p -18:$ip:".(3000+$adapter);
my $i = 0;

unless (open(FILE, "<$chan_file")) {
	print("Sorry, could not open channelfile $chan_file\n");
	exit();
}
my $pls_file = sprintf($playlistinfo, $ip, $adapter);
unless (open(PLIST, '>'.$pls_file)) {
	print("Sorry, could not open playlistfile $pls_file\n");
	exit();
}
while (<FILE>) {
	chomp;
	my @tmp = split(":",$_);
	if ($tmp[1] == $frequency) {
		print "$_\n";
		if ($multicast) {
			$command .= " -p $tmp[7]:239.255.$transponder.$i:2000";
			print(PLIST "udp://\@239.255.$transponder.$i:2000\t");
		} else {
			my $portad = 2000 + $adapter*100 + $i;
			$command .= " -p $tmp[7]:$ip:$portad";
			print(PLIST "http://$ip:$portad\t");
		}
		print(PLIST "$tmp[5]\t$tmp[6]\t$tmp[7]\t$tmp[0]\n");
		$i++;
	}
}
close(PLIST);
close(FILE);

if ($plstarget ne '') {
	print("Copying over playlist...\n");
	system("scp", $pls_file, $plstarget);
}
print "\n";
print $command;
print "\n";

system ($command);
